declare const QR_CODE: string;
declare const DEFAULT_BANNER: string;
declare const DEFAULT_POSTER: string;
declare const BAR: string;

/// <reference types="cc" />

export function enterReport(appid: string, userid: string): void;

export class RecommendUI {
  window: cc.Node;
  games: Array<object>;
  moreGames: Array<object>;
  banner: string;
  poster: string;
  specPanels: Array<string>;
  gameIcons: Array<string>;
  moreGameIcons: Array<string>;
  bannerImage: cc.Texture2D;
  bar: cc.Texture2D;
  panel: cc.Texture2D;
  circle: cc.Texture2D;
  line: cc.Texture2D;
  reconnectBtn: cc.Texture2D;
  offlineTips: cc.Texture2D;
  mode: string;
  root: cc.Node;
  scrollView: cc.Node;
  gameListContainer: cc.Node;
  gameListPanels: Array<cc.Node>;
  moreGamePanel: cc.Node;
  gameBanner: cc.Node;
  offlineNode: cc.Node | undefined;
  title: cc.Node;
  background: cc.Node;
  width: number;
  height: number;
  measureScale: number;
  appid: string;
  openid: string;
  touching: boolean;
  firstShow: boolean;
  loadSuccess: boolean;

  constructor(options: object);

  getSession(): void;
  fetchData(): void;
  loadResource(): void;
  loadOfflineResource(): void;
  createNode(options: object);
  addComponent(node: cc.Node, component: object, options: object): void;
  request(method: string, url: string, data: object): Promise;
  loadRemoteImage(url: string): Promise;
  loadResource(): void;
  createUI(): void;
  createOfflineUI(): void;
  createScrollView(): cc.Node;
  bindScrollEvents(node: cc.Node): void;
  checkExposedGames(first: boolean): void;
  reportItem(datas: Array<object>, i: number, actionId: number, slotId: number): void;
  createContainer(): cc.Node;
  createGameListPanels(parent: object): Array<cc.Node>;
  bindTouchEvent(node: object, cb: () => void): void;
  showQrcode(data: object): void;
  createTitle(): cc.Node;
  initTitle(): void;
  createMoreGamePanel(parent: cc.Node): cc.Node;
  drawArrow(ctx: cc.Graphics, w: number, h: number): void;
  createGameBanner(parent: cc.Node): cc.Node;
  initRoot(): void;
  calSize(): void;
  createBackground(): void;
  drawRect(ctx: cc.Graphics, width: number, height: number, color: cc.Color, opacity: number);
  drawRoundRect(ctx: cc.Graphics, width: number, height: number, color: cc.Color, opacity: number);
  hide(): void;
  show(): void;
  firstReport(): void;
  report(datas: Array<any>): void;
  choose(portraitVal: any, landscapeVal: any): any;
}
